diff --git a/src/test/perl/PostgresNode.pm b/src/test/perl/PostgresNode.pm
index 2cbd288..e42c117 100644
--- a/src/test/perl/PostgresNode.pm
+++ b/src/test/perl/PostgresNode.pm
@@ -668,6 +668,24 @@ sub stop
 
 =pod
 
+=item $node->reload()
+
+Reload configuration parameters on the node.
+
+=cut
+
+sub reload
+{
+	my ($self) = @_;
+	my $port   = $self->port;
+	my $pgdata = $self->data_dir;
+	my $name   = $self->name;
+	print "### Reloading node \"$name\"\n";
+	TestLib::system_log('pg_ctl', '-D', $pgdata, 'reload');
+}
+
+=pod
+
 =item $node->restart()
 
 Wrapper for pg_ctl -w restart