diff --git a/src/bin/initdb/initdb.c b/src/bin/initdb/initdb.c
index d4a5e7c..3796213 100644
--- a/src/bin/initdb/initdb.c
+++ b/src/bin/initdb/initdb.c
@@ -199,6 +199,9 @@ static const char *backend_options = "--single -F -O -j -c search_path=pg_catalo
 
 static const char *const subdirs[] = {
 	"global",
+#if defined(DEBUG) && defined(WIN32)
+	"crashdumps",
+#endif
 	"pg_xlog/archive_status",
 	"pg_clog",
 	"pg_commit_ts",